//*CMZ :  2.23/12 26/01/2000  11.46.16  by  Rene Brun
//*CMZ :  2.23/04 10/10/99  10.45.29  by  Fons Rademakers
//*CMZ :  2.23/02 07/09/99  10.45.08  by  Fons Rademakers
//*CMZ :  2.22/06 21/06/99  18.02.51  by  Rene Brun
//*CMZ :  2.21/08 11/03/99  08.16.09  by  Rene Brun
//*CMZ :  1.03/09 06/12/97  17.45.42  by  Fons Rademakers
//*-- Author :    Rene Brun   05/12/95

//*KEEP,CopyRight,T=C.
/*************************************************************************
 * Copyright (C) 1995-2000, Rene Brun and Fons Rademakers.               *
 * All rights reserved.                                                  *
 *                                                                       *
 * For the licensing terms see $ROOTSYS/LICENSE.                         *
 * For the list of contributors see $ROOTSYS/README/CREDITS.             *
 *************************************************************************/
//*KEND.

//*KEEP,TVirtualPad.
#include "TVirtualPad.h"
//*KEEP,X3DBuffer,T=C.
#include "X3DBuffer.h"
//*KEND.

Size3D gSize3D;

void **(*gThreadTsd)(void*,Int_t) = 0;
Int_t (*gThreadXAR)(const char *xact, Int_t nb, void **ar, Int_t *iret) = 0;

//______________________________________________________________________________
TVirtualPad *&gPad
{
   static TVirtualPad *currentPad = 0;
   if (!gThreadTsd)
      return currentPad;
   else
      return *(TVirtualPad**)(*gThreadTsd)(&currentPad,0);
}


ClassImp(TVirtualPad)

//______________________________________________________________________________
//
//  TVirtualPad is an abstract base class for the Pad and Canvas classes.
//

//______________________________________________________________________________
TVirtualPad::TVirtualPad() : TAttPad()
{
   // VirtualPad default constructor

   fResizing = kFALSE;
}

//______________________________________________________________________________
TVirtualPad::TVirtualPad(const char *, const char *, Float_t,
           Float_t, Float_t, Float_t, Color_t color, Short_t , Short_t)
          : TAttPad()
{
   // VirtualPad constructor

   fResizing = kFALSE;

   SetFillColor(color);
   SetFillStyle(1001);
}

//______________________________________________________________________________
TVirtualPad::~TVirtualPad()
{
   // VirtualPad destructor

}

