
#ifndef ROOT_PosixThreadInc
#define ROOT_PosixThreadInc

//+SEQ,CopyRight,T=NOINCLUDE.

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// PosixThreadInc                                                       //
//                                                                      //
// Common includes for the Posix thread implementation.                 //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#ifndef __CINT__

#ifndef ROOT_TError
//*KEEP,TError.
#include "TError.h"
//*KEND.
#endif
#ifndef ROOT_TSystem
//*KEEP,TSystem.
#include "TSystem.h"
//*KEND.
#endif

#include <stdlib.h>
#include <time.h>

#if defined(R__LINUX)
#define PthreadDraftVersion 10
#elif defined(R__HPUX)
#define PthreadDraftVersion 4
#else
#warning PthreadDraftVersion not specified
#endif


#if (PthreadDraftVersion <= 6)
#define ERRNO(x) (((x) != 0) ? (TSystem::GetErrno()) : 0)
#else
#define ERRNO(x) (x)
#endif

#endif /* __CINT__ */

#endif
