
#ifndef ROOT_TFileSet
#define ROOT_TFileSet

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TFileSet                                                             //
//                                                                      //
// TFileSet class is a class to convert the                             //
//      "native file system structure"                                  //
// into an instance of the TDataSet class                               //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

//*KEEP,TDataSet,T=C++.
#include "TDataSet.h"
//*KEEP,TString.
#include "TString.h"
//*KEND.

class TFileSet : public TDataSet
{
 public:
    TFileSet();
    TFileSet(const TString &dirname, const Char_t *filename=0,Bool_t expand=kTRUE);
    virtual ~TFileSet();
    virtual Long_t HasData() const;
    virtual Bool_t IsEmpty() const;
    virtual Bool_t IsFolder();
    ClassDef(TFileSet,1)
};

#endif
