
#ifndef ROOT_TVolumeViewIter
#define ROOT_TVolumeViewIter

//*KEEP,TDataSetIter,T=C++.
#include "TDataSetIter.h"
//*KEEP,TVolumePosition,T=C++.
#include "TVolumePosition.h"
//*KEND.

class TObjArray;
class TVolumeView;

class TVolumeViewIter : public TDataSetIter {
private:
protected:
     friend class TVolumeView;
     TObjArray    *fPositions; // the array of the Node position in the absolute system
     virtual const TVolumePosition *GetPosition(Int_t level=0) const;
     virtual TVolumePosition *SetPositionAt(TVolume *node,Double_t x=0, Double_t y=0, Double_t z=0, TRotMatrix *matrix=0);
     virtual TVolumePosition *SetPositionAt(TVolumePosition &curPosition);
public:
     TVolumeViewIter(TVolumeView *view, Int_t depth=1, Bool_t dir=kIterForward);
    ~TVolumeViewIter();
     virtual void            Notify(TDataSet *set);
     virtual void            Reset(TDataSet *l=0,Int_t depth=0);

     TVolumePosition        *operator[](Int_t level) const ;

     TVolumePosition        *UpdateTempMatrix(TVolumePosition *curPosition);
     void                    ResetPosition(Int_t level=0, TVolumePosition *newPosition=0);
     ClassDef(TVolumeViewIter,0)
};


#endif

